###############################################################################
# BoardIndex.pl                                                               #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$boardindexplver = "1 Gold - SP 1.3";

sub BoardIndex {
	#RECENT USERS LIST MOD START
	if ($username ne 'Guest')
	{
		require "$sourcedir/LogInOut.pl";
		&RecentUsersList;
	}
	#RECENT USERS LIST MOD END
	# Open the file with all categories
	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$yyCatsLoaded = 1;
	my($memcount, $latestmember) = &MembershipGet;
	$totalm = 0;
	$totalt = 0;
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$catname{$curcat} = <FILE>;
		chomp $catname{$curcat};
		$cataccess{$curcat} = <FILE>;
		chomp $cataccess{$curcat};
		@{$catboards{$curcat}} = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $cataccess{$curcat} );
		$openmemgr{$curcat} = 0;
		my($mscount);
		$mscount=0;
		foreach $tmpa (@membergroups) {
			if( $tmpa eq $settings[7]) { $openmemgr{$curcat} = 1; last; }
	while($MemStat[$mscount]) {
	if($settings[6] >= $MemPostNum[$mscount] && $MemPostNum[$mscount] ne "x") {
	$memberinfo = "$MemStat[$mscount]"; }
	++$mscount;
	}
	if ( $memberinfo eq $tmpa ) { $openmemgr{$curcat} = 1; last; }
		}
		if( ! $cataccess{$curcat} || $settings[7] eq 'Administrator' ) { $openmemgr{$curcat} = 1; }
		unless($openmemgr{$curcat}) { next; }
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($curboard);

			$lastposttime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? $txt{'470'} : &timeformat($lastposttime);
			$lastpostrealtime{$curboard} = $lastposttime eq 'N/A' || ! $lastposttime ? '' : $lastposttime;
			if( $lastposter =~ m~\AGuest-(.*)~ ) {
				$lastposter = $1;
				$lastposterguest{$curboard} = 1;
			}
			$lastposter{$curboard} = $lastposter eq 'N/A' || ! $lastposter ? $txt{'470'} : $lastposter;
			$messagecount{$curboard} = $messagecount || 0;
			$threadcount{$curboard} = $threadcount || 0;
			$totalm += $messagecount;
			$totalt += $threadcount;
		}
	}

	$curforumurl = $curposlinks ? qq~<a href="$scripturl" class="nav">$mbname</a>~ : $mbname;
	#RECENT MEMBERS MOD START
	if ($rul_show_avatars && ($rul_avatar_width || $rul_avatar_height)) { $yymain .= qq~
<script language="JavaScript1.2" type="text/javascript">
<!--
function resize_img(imgsrc, alttxt) {
	tmp_image = new Image;
	tmp_image.src = imgsrc;

	maxwidth = $rul_avatar_width;
	maxheight = $rul_avatar_height; 

	if (maxwidth != 0 && tmp_image.width > maxwidth) {
		tmp_image.height = (tmp_image.height * maxwidth / tmp_image.width);
		tmp_image.width = maxwidth;
	}
	if (maxheight != 0 && tmp_image.height > maxheight) {
		tmp_image.width = tmp_image.width * maxheight / tmp_image.height;
		tmp_image.height = maxheight;
	}

	document.write( '<img src="' + tmp_image.src + '" width="' + tmp_image.width + '" height="' + tmp_image.height + '" alt="' + alttxt + '" border="0" hspace="3">' )
}
// -->
</script>
~; }
	#RECENT MEMBERS MOD END

	$yymain .= qq~~;
	if($shownewsfader == 1) {
		if(!$fadedelay) { $fadedelay = 5000; }
		$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'102'}</b></font></td>
      </tr><tr>
        <td bgcolor="$color{'scrollbg'}" class="scrollbg" valign="middle" align="center" height="18">
<center>
<script language="JavaScript1.2">

/*
Pausing updown message scroller- 
 Dynamic Drive (www.dynamicdrive.com)
For full source code, installation instructions,
Terms Of Use, visit http://www.dynamicdrive.com
*/

//configure the below five variables to change the style of the scroller
var scrollerwidth='745px'
var scrollerheight='18px'
var scrollerbgcolor=''
//set below to '' if you don't wish to use a background image
var scrollerbackground=''

//configure the below variable to change the contents of the scroller
var messages=new Array()
messages[0]="<b>Casey finishes 18th at Bristol</b>"
messages[1]="<b>Happy 23rd Birthday Casey!!!</b></font>"
messages[2]="<b>Trivia: What do Spiderman, Rowlff the Dog, and Frankenstein all have in common?</b></font>"
messages[3]="<b>Chat with Fellow Casey fans:  Wednesday at 9 PM EST</b></font>"
messages[4]="<b>Welcome Trent, BudGirl12, 7atwoodfan,southgaleadfoot, onyxstar!!</b></b></font>"
messages[5]="<b>Trivia Answer: They have all been part of Casey's special paint schemes</b></font>"

///////Do not edit pass this line///////////////////////

var ie=document.all
var dom=document.getElementById

if (messages.length>2)
i=2
else
i=0

function move1(whichlayer){
tlayer=eval(whichlayer)
if (tlayer.top>0&&tlayer.top<=5){
tlayer.top=0
setTimeout("move1(tlayer)",5000)
setTimeout("move2(document.main.document.second)",5000)
return
}
if (tlayer.top>=tlayer.document.height*-1){
tlayer.top-=5
setTimeout("move1(tlayer)",75)
}
else{
tlayer.top=parseInt(scrollerheight)
tlayer.document.write(messages[i])
tlayer.document.close()
if (i==messages.length-1)
i=0
else
i++
}
}

function move2(whichlayer){
tlayer2=eval(whichlayer)
if (tlayer2.top>0&&tlayer2.top<=5){
tlayer2.top=0
setTimeout("move2(tlayer2)",5000)
setTimeout("move1(document.main.document.first)",5000)
return
}
if (tlayer2.top>=tlayer2.document.height*-1){
tlayer2.top-=5
setTimeout("move2(tlayer2)",75)
}
else{
tlayer2.top=parseInt(scrollerheight)
tlayer2.document.write(messages[i])
tlayer2.document.close()
if (i==messages.length-1)
i=0
else
i++
}
}

function move3(whichdiv){
tdiv=eval(whichdiv)
if (parseInt(tdiv.style.top)>0&&parseInt(tdiv.style.top)<=5){
tdiv.style.top=0+"px"
setTimeout("move3(tdiv)",5000)
setTimeout("move4(second2_obj)",5000)
return
}
if (parseInt(tdiv.style.top)>=tdiv.offsetHeight*-1){
tdiv.style.top=parseInt(tdiv.style.top)-5+"px"
setTimeout("move3(tdiv)",75)
}
else{
tdiv.style.top=parseInt(scrollerheight)
tdiv.innerHTML=messages[i]
if (i==messages.length-1)
i=0
else
i++
}
}

function move4(whichdiv){
tdiv2=eval(whichdiv)
if (parseInt(tdiv2.style.top)>0&&parseInt(tdiv2.style.top)<=5){
tdiv2.style.top=0+"px"
setTimeout("move4(tdiv2)",5000)
setTimeout("move3(first2_obj)",5000)
return
}
if (parseInt(tdiv2.style.top)>=tdiv2.offsetHeight*-1){
tdiv2.style.top=parseInt(tdiv2.style.top)-5+"px"
setTimeout("move4(second2_obj)",75)
}
else{
tdiv2.style.top=parseInt(scrollerheight)
tdiv2.innerHTML=messages[i]
if (i==messages.length-1)
i=0
else
i++
}
}

function startscroll(){
if (ie||dom){
first2_obj=ie? first2 : document.getElementById("first2")
second2_obj=ie? second2 : document.getElementById("second2")
move3(first2_obj)
second2_obj.style.top=scrollerheight
second2_obj.style.visibility='visible'
}
else if (document.layers){
document.main.visibility='show'
move1(document.main.document.first)
document.main.document.second.top=parseInt(scrollerheight)+5
document.main.document.second.visibility='show'
}
}

window.onload=startscroll

</script>


<ilayer id="main" width=&{scrollerwidth}; height=&{scrollerheight}; bgColor=&{scrollerbgcolor}; background=&{scrollerbackground}; visibility=hide>
<layer id="first" left=0 top=1 width=&{scrollerwidth};>
<script language="JavaScript1.2">
if (document.layers)
document.write(messages[0])
</script>
</layer>
<layer id="second" left=0 top=0 width=&{scrollerwidth}; visibility=hide>
<script language="JavaScript1.2">
if (document.layers)
document.write(messages[dyndetermine=(messages.length==1)? 0 : 1])
</script>
</layer>
</ilayer>

<script language="JavaScript1.2">
if (ie||dom){
document.writeln('<div id="main2" style="position:relative;width:'+scrollerwidth+';height:'+scrollerheight+';overflow:hidden;background-color:'+scrollerbgcolor+' ;background-image:url('+scrollerbackground+')">')
document.writeln('<div style="position:absolute;width:'+scrollerwidth+';height:'+scrollerheight+';clip:rect(0 '+scrollerwidth+' '+scrollerheight+' 0);left:0px;top:0px">')
document.writeln('<div id="first2" style="position:absolute;width:'+scrollerwidth+';left:0px;top:1px;">')
document.write(messages[0])
document.writeln('</div>')
document.writeln('<div id="second2" style="position:absolute;width:'+scrollerwidth+';left:0px;top:0px;visibility:hidden">')
document.write(messages[dyndetermine=(messages.length==1)? 0 : 1])

}
</script>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
	}
	$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0">
  <tr>
    <td>~;

	#Check to see if the subcat.txt doesn't exist, if it doesn't we still need a forum header or it looks funny
	if(!(-e "$vardir/subcat.txt"))
	{
		$yymain .= qq~
		<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		  <tr>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'20'}</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
		    <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
		   </tr>
		  ~;
	}

	#This bit of code goes through and checks if we have visible categories. If there are no visible
	# categories, we need to still insert a <TABLE> string or else the info table will expand to full screen.
	$catisvisible="false";
	foreach $curcat (@categories)
	{
		unless( $openmemgr{$curcat} ) { next; }
		$catisvisible="true";
	}
	if($catisvisible eq "false")
	{
		$yymain .= qq~
		<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		~;
	}

	#Go through the categories and creat the tables if they are needed
	$foundasubcat="false";
	foreach $curcat (@categories)
	{
		unless( $openmemgr{$curcat} ) { next; }
		####
		if ($catpic{$curcat} =~ /\//i) {$catpic{$curcat} = qq~ <img src="$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		elsif ($catpic{$curcat}) {$catpic{$curcat} = qq~ <img src="$imagesdir/$catpic{$curcat}" alt="" border="0" align="absmiddle"> ~;}
		####

		fopen(FILE, "$vardir/subcat.txt");
		@subcategories = <FILE>;
		fclose(FILE);
		$newsubcatlist="";

		#Go through the subcats and check to see if the curcat is found in the subcats file (It is a subcategory)
		foreach $cursubcat (@subcategories)
		{
			chomp($cursubcat);
			($cursubcatid,$cursubcatname) = split(/\|/,$cursubcat);
	
			#Check if we found a match
			if ($curcat eq $cursubcatid)
			{
				$foundasubcat="true";

				#This little code breaks the table away from the previous category
				if ($curcat ne @categories[0]) { $yymain .= qq~</TABLE><P>~; }

				 $yymain .= qq~
				    <table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
				      <tr>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>$cursubcatname</b></font></td>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
				        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
				      </tr>
				~;
			}
		}

		#This code adds a table header for the very first category if the very first category is not found in subcat.txt
		if ((-e "$vardir/subcat.txt") && $foundasubcat eq "false")
		{
			$foundasubcat="true";
			$yymain .= qq~
			<table cellpadding="4" cellspacing="1" border="0" width="100%" bgcolor="$color{'bordercolor'}" class="bordercolor">
		  	  <tr>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" colspan="2"><font class="text1" color="$color{'titletext'}" size="2"><b>Forum Name</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'330'}</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="1%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'21'}</b></font></td>
		    	    <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%" align="center"><font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'22'}</b></font></td>
		   	  </tr>
		  	~;
		}
		$yymain .= qq~<tr>
        <td colspan="5" class="catbg" bgcolor="$color{'catbg'}" height="18"><a name="$curcat"> $catpic{$curcat}<font size="2"><b>$catname{$curcat}</b></font></a></td>
      </tr>~;
		foreach $curboard (@{$catboards{$curcat}}) {
			chomp $curboard;
			my $access = &AccessCheck($curboard, '');
			if ($settings[7] ne "Administrator" && $access ne "granted" && $showprivboards{$curboard} ne "1") {next;}
			fopen(FILE, "$boardsdir/$curboard.dat");
			$curboardname = <FILE>;
			chomp $curboardname;
			$curboarddescr = <FILE>;
			chomp $curboarddescr;
			$curboardmods = <FILE>;
			chomp $curboardmods;
			fclose(FILE);
			%moderators = ();
			foreach $curuser (split(/\|/, $curboardmods)) {
				&LoadUser($curuser);
				$moderators{$curuser} = $userprofile{$curuser}->[1];

			}
			$showmods = '';
			if(scalar keys %moderators == 1) { $showmods = qq~$txt{'298'}: ~; }
			elsif(scalar keys %moderators != 0) { $showmods = qq~$txt{'299'}: ~; }
			while($tmpa = each(%moderators)) {
				&FormatUserName($tmpa);
				$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
			}
			$showmods =~ s/, \Z//;
			if($showmods eq "") { $showmods = qq~$txt{'298'}: $txt{'470'}~; }
			$dlp = &getlog($curboard);
			if( $max_log_days_old && $lastposttime{$curboard} ne $txt{'470'} && $username ne 'Guest' && $dlp < stringtotime( $lastpostrealtime{$curboard} ) ) {
				$new = qq~<img src="$imagesdir/on.gif" alt="$txt{'333'}" border="0">~;
			}
			else { $new = qq~<img src="$imagesdir/off.gif" alt="$txt{'334'}" border="0">~; }
			$lastposter = $lastposter{$curboard};
			unless( $lastposterguest{$curboard} || $lastposter{$curboard} eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			$lastposter ||= $txt{'470'};
			$lastposttime ||= $txt{'470'};
			####
			$boardpic = "";
			if (-e "$boardsdir/$curboard.mbo" ) { require "$boardsdir/$curboard.mbo"; }
			if ($boardpic{$curboard} =~ /\//i) {$boardpic{$curboard} = qq~ <img src="$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}
			elsif ($boardpic{$curboard}) {$boardpic{$curboard} = qq~ <img src="$imagesdir/$boardpic{$curboard}" alt="" border="0" align="absmiddle"> ~;}

			my $cookiename = "$cookiepassword$curboard";
			my $crypass = crypt($boardpw{$curboard},$pwseed);
			my $boardpwpic = "";
			if ($settings[7] ne "Administrator" && $boardpw{$curboard} && $yyCookies{$cookiename} ne $crypass) {$boardpwpic = qq~<img border="0" alt="" align="absmiddle" src="$imagesdir/locking.gif">~;}
			elsif ($boardpw{$curboard}) {$boardpwpic = qq~<img border="0" align="absmiddle" alt="" src="$imagesdir/lockopen.gif">~;}
			####
			$yymain .= qq~<tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="8%" align="center" valign="top">$new</td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" align="left" width="66%">
        <font size="2"><a name="$curboard" href="$scripturl?board=$curboard">$boardpic{$curboard}<b>$curboardname $boardpwpic</b></a></font>
        <br><font size="1">$curboarddescr<BR>
        <i>$showmods</i></font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$threadcount{$curboard}</font></td>
        <td class="windowbg" bgcolor="$color{'windowbg'}" valign="middle" align="center" width="1%"><font size="2">$messagecount{$curboard}</font></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="middle" width="24%"><font size="1">$lastposttime{$curboard}<BR>$txt{'525'} $lastposter</font></td>
      </tr>~;
		}
	}
	my $checkadded = 0;
	$guests = 0;
	$users = '';
	$numusers = 0;
	foreach $curentry (@online_log) {
		my ($tmp_name, $tmp_online, $tmp_ip, $tmp_time, $dummy ) = split( /\|/, $curentry, 5 );
		if (($time - $tmp_time) > ($OnlineLogTime * 60)) {last;}
		if($tmp_name && $tmp_online) {
			if(!$yyUDLoaded{$tmp_name}) { &LoadUser($tmp_name); }
			if(exists $userprofile{$tmp_name} && $user_found{$tmp_name} ne "true") {
				$numusers++;
				$users .= qq~ <a href="$scripturl?action=viewprofile;username=$useraccount{$tmp_name}">$userprofile{$tmp_name}->[1]</a><font size="1">,</font> \n~;
				$user_found{$tmp_name} = "true";
			} elsif($tmp_name eq "Guest" && $user_found{$tmp_ip} ne "true") {
				$guests++;
				$user_found{$tmp_ip} = "true";
			}
		}
	}
	$users =~ s~<font size="1">,</font> \n\Z~~;
	if($username ne 'Guest') {
		$ims = @immessages;
### LIMITED IM MOD ###
if($userimcfg[5] eq "on") {
$yymain .= qq~<script language="javascript"> function viewinstant() { window.open("$scripturl?action=im") } </script>~; }
else {
$yymain .= qq~<script language="javascript"> function viewinstant() { location.href = ("$scripturl?action=im") } </script>~; }

if ($minnum > $numibox && $numibox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $minnum $imtxt{'12'} $txt{'316'}!\\n$numibox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IM; 
}

if ($moutnum > $numobox && $numobox ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $moutnum $imtxt{'12'} $txt{'320'}!\\n$numobox $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_IMOUT; 
}

if ($storenum > $numstore && $numstore ne "" && $enable_imlimit == 1) {
	$yymain .= qq~<script language="javascript"> if(confirm('$imtxt{'11'} $storenum $imtxt{'12'} $imtxt{'46'}!\\n$numstore $imtxt{'18'}')) { viewinstant(); } else cancel() </script>~;
		&Del_Max_STORE; 
}

$ims = qq~<BR>$txt{'796'} <a href="$scripturl?action=im"><B>$ims</B></a> $imtxt{'24'}: <a href="$scripturl?action=im"><B>$imnewcount</B></a>~;

### END LIMITED IM ###
		$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="6" align="center">
        <table cellpadding="0" border="0" cellspacing="0" width="100%">
          <tr>
            <td align="left"> <font size="1" class="text5">
            <img src="$imagesdir/on.gif" border=0 alt="$txt{'333'}"> $txt{'333'}&nbsp;&nbsp;
            <img src="$imagesdir/off.gif" border=0 alt="$txt{'334'}"> $txt{'334'}</font></td>
            <td align="right"><font size=1 class="text5">&nbsp;
~;
	if($showmarkread) { $yymain .= qq~<a href="$scripturl?action=markallasread">$img{'markallread'}</a>~; }
	$yymain .= qq~
            </font></td>
          </tr>
        </table>
        </td>
      </tr>~;
	}

	#set the correct rowspan for the recent users list main cell
	#this setting works with the standard yabb info centre (rowspan 6 for guests, 4 when logged in)
	$rul_rowspan = ($username eq 'Guest') ? 6 : 4;

	#the following add-on compatibility settings aren't guaranteed to work because these mods don't have specific settings to let us know whether anything has been added to the info centre
	#the compromise is to check if a variable used by these mods exists, and if so presume the mod has been added to the info centre 
	#compatibility with the New Calendar mod by Ironwing, GauGau, & Nermware
	if ($newcalspread || $newcalindexmini) { $rul_rowspan += 2; }
	#compatibility with the YaBB Chat! for YaBB Gold SP1 mod by _Max, Omario, Samm
	if (-e("$vardir/ChatSettings.txt"))
	{
		require "$vardir/ChatSettings.txt";

		chomp $chatgroup;
		@chatgrouplist = split(",",$chatgroup);
		$chatgroupflag = 0;
		foreach $chatgroupitem (@chatgrouplist)
		{
			if ($settings[7] eq $chatgroupitem) { $chatgroupflag = 1; }
		}

		if ($chatopen == 1 || $chatgroupflag == 1 || ($chatopen == 0 && $settings[7] eq 'Administrator')) { $rul_rowspan += 2; }
	}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>

<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
 <td>

    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2">
        <font class="text1" color="$color{'titletext'}" size="2"><b>$txt{'685'}</b></font></td>
		<td bgcolor="$color{'titlebg'}" class="titlebg" align="center" colspan="2">
        <font class="text1" color="$color{'titletext'}" size="2"><b>$rul_users_display $lud_txt{'1'}</b></font></td>
      </tr>~;
	$yymain .= qq~<tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$txt{'200'}</b></font></td>
		<td rowspan="$rul_rowspan" class="windowbg2" bgcolor="$color{'windowbg'}" valign="top" width="25%">~;
	  
	&RecentUsersListShow;
	
	$yymain .= qq~
      </td></tr><tr>   <td>
   <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/info.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}" valign="top" align="center"><font size="1"> 
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left" width="60%"><font size="1" class="text2">
            $txt{'490'} <B>$totalt</B> &nbsp; - &nbsp; $txt{'489'} <B>$totalm</B>
	    ~;
	if($Show_RecentBar) {
		require "$sourcedir/Recent.pl";
		&LastPost;
	}
	$yymain .= qq~
	    </font></td>
	    <td valign="top" align="left" width="40%"><font size="1" class="text2">
	    $txt{'488'} <a href="$scripturl?action=mlall"><B>$memcount</B></a>
	    ~;
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$yymain .= qq~<BR>$txt{'201'}: <a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>$userprofile{$latestmember}->[1]</b></a>~;
	}
	$yymain .= qq~
	    $ims
	    </font></td>
	  </tr>
	</table>
	</font></td>
      </tr><tr>
~;
	if ($forum_staff) {
		# Load MemberGroups
		if(!$MemStatAdmin) {
			fopen(FILE, "$vardir/membergroups.txt") || &fatal_error("100 $txt{'106'}: $txt{'23'} membergroups.txt");
			@membergroups = <FILE>;
			fclose(FILE);
			chomp $membergroups[0]; $tmp_admin_txt = $membergroups[0] || "Administrator";
			chomp $membergroups[7]; $tmp_gmod_txt =  $membergroups[7] || "Global Moderator";
		} else {
			$tmp_admin_txt = $MemStatAdmin || "Administrator";
			$tmp_gmod_txt = $MemStatGMod || "Global Moderator";
		}

		fopen(FILE, "$vardir/mem_groups.txt");
		@mem_groups = <FILE>;
		fclose(FILE);
		@mem_groups = sort{uc($a) cmp uc($b)} (@mem_groups);
		foreach $curentry (@mem_groups) {
			chomp $curentry;
			($tmp_username, $tmp_group, $tmp_name) = split(/\|/, $curentry);
			if ($group_list{$tmp_group}) { $group_list{$tmp_group} .= qq~, ~;}
			$group_list{$tmp_group} .= qq~<a href="$scripturl?action=viewprofile;username=$tmp_username">$tmp_name</a>~;
		}

		@staff = split (/,/, $forum_staff);
		$list = "";
		foreach $curentry (@staff) {
			$curentry =~ s~^\s*(\S.*?\S|\S)\s*$~$1~; 
			if($curentry eq "Administrator") {$tmp_group_txt = $tmp_admin_txt;} 
			elsif($curentry eq "Global Moderator") {$tmp_group_txt = $tmp_gmod_txt;} 
			else {$tmp_group_txt = $curentry;} 
			if ($group_list{$curentry}) { $list .= qq~
             <tr>
               <td width="10%" valign="top" nowrap><font size="1"><b>$tmp_group_txt:</b>&nbsp;</font></td><td valign="top"><font size="1">$group_list{$curentry}</font></td>
             </tr>~;
			}
		}

		if ($list) {$yymain .= qq~
          <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2"><b>$txt{'509c'}</b></font></td>
        </tr><tr>
         <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/admin.gif" border="0" alt="" align="absmiddle"></td>
         <td class="windowbg2" bgcolor="$color{'windowbg2'}">
           <table width="98%" cellpadding="0" align="center">$list
           </table>
         </td>
       </tr><tr>~;
		}
	}
	$yymain .= qq~
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg2"><b>$txt{'158'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><img src="$imagesdir/online.gif" border="0" alt=""></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1">
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1" class="text2">
            $guests $txt{'141'}, $numusers $txt{'142'}<BR>$users
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
########### Newcalendar mod start #######################
	chomp $newcalgroup;
	@newcalgrouplist = split(",",$newcalgroup);
	$newcalgroupflag = 0;
	foreach $newcalgroupitem (@newcalgrouplist) {
		if ($settings[7] eq $newcalgroupitem) { $newcalgroupflag = 1; }
	}
if ($newcalopen == 1 || $settings[7] eq 'Administrator' || $newcalgroupflag ==1 ) {
	if ($newcalmoon2 == 1) {
		require "$sourcedir/MoonPhase.pl";                           #This is the moon phase calculator
		( $MoonPhase, $MoonIllum, $MoonAge, $MoonDist, $MoonAng, $SunDist, $SunAng ) = phase();
		my ($newphaselow) = 0.016666667;
		my ($newphasehigh) = 0.983333333;
		my ($phaseincrement) = 0.033333333;

		if ( ($MoonPhase < $newphaselow) || ($MoonPhase > $newphasehigh) ){
			$moonpict = qq~<img src="$imagesdir/moon00.gif" alt="" border="0">~;
		} else {
			$gifnumber = 1;
			for ($phasescan = $newphaselow; $phasescan < $newphasehigh; $phasescan += $phaseincrement) {
				if ( ($MoonPhase > $phasescan) && ( $MoonPhase <= ($phasescan + $phaseincrement)) ){
					if ($gifnumber < 10) {
						$moonpict = qq~<img src="$imagesdir/moon0$gifnumber.gif" alt="" border="0">~;
					} else {
						$moonpict = qq~<img src="$imagesdir/moon$gifnumber.gif" alt="" border="0">~;
					}
				}
				$gifnumber++;
			}
		}
	} else {
		$moonpict = qq~<img src="$imagesdir/newcal.gif" alt="" border="0">~;
	}
	$yymain .=qq~
       <tr>
        <td class="catbg" bgcolor="$color{'catbg'}" colspan="2"> <font size="2" class="catbg"><b>$ecaltxt{'55'}</b></font></td>
      </tr><tr>
        <td class="windowbg" bgcolor="$color{'windowbg'}" width="20" valign="middle" align="center"><a href="$cgi;action=newcalendar">$moonpict</a></td>
        <td class="windowbg2" bgcolor="$color{'windowbg2'}"><font size=1>
        <table width="98%" cellpadding="3" align="center">
          <tr>
            <td valign="top" align="left"><font size="1">~;
require "$sourcedir/NewcalIndex.pl";
if ($newcalindexmini == 1) {
	$yymain .=qq~
<table width='100%'>
  <tr>
    <td valign='top'>
      <font size="1">~;
        &IndexCal;
	$yymain .=qq~
      </font>
    </td><td align='right'>~;
	require "$sourcedir/NewcalPost.pl";
      &MiniCalYY;
      $yymain .=qq~$yyminical~;
	$yymain .=qq~
    <td>
  </tr>
</table>~;
} else {
	&IndexCal;
}
$yymain .=qq~  
            </font></td>
          </tr>
        </table>
        </font></td>
      </tr>~;
}
########### Newcalendar mod end #######################

	if($username eq 'Guest') {
		require "$sourcedir/LogInOut.pl";
		$sharedLogin_title="$txt{'34'} <small><a href=\"$cgi;action=reminder\">($txt{'315'})</a></small>";
		&sharedLogin;
	}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
~;
	if($imnewcount > 0 && $enable_mailpopup == 1) {
		if($imnewcount > 1) { $en = "s"; $en2 = "$imtxt{'47'}"; } else { $en = ""; $en2 = "$imtxt{'48'}"; }

		open(FILE, "$memberdir/$username.imconfig");
		@imuserdata = <FILE>;
		close(FILE);

		chomp($imuserdata[3]);
		chomp($imuserdata[5]);

		if($imuserdata[3] eq "on") {
	if($imuserdata[5] eq "on") {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { window.open("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	} else {
	$yymain .= qq~
	<script language="JavaScript">
	function rimpu() { location.href = ("$scripturl?action=im") }
	function cancel () { }
	</script>~;
	}
		$yymain .= qq~
	<script language="JavaScript">
	<!-- BEGIN
		if (confirm("$imtxt{'13'} $imnewcount $imtxt{'14'}$en$imtxt{'15'} $en2?")) { rimpu(); } else cancel()
	// END --> 
	</script>
		~;
		}
	}
	$yytitle = "$txt{'18'}";
	&template;
	exit;
}

#RECENT USERS LIST
#v1.2.1
#OUTPUTS A TABLE WITH $rul_users_display ROWS - ONE FOR EACH USER IN THE LIST
sub RecentUsersListShow
{
	fopen(FILE, "$vardir/lastuseronline.txt"); @lastusers = <FILE>; fclose(FILE); chomp @lastusers;
	$counter = 1;
	
	$yymain .= qq~<table border="0" cellspacing="0" cellpadding="3">~;
	
	foreach $lastuser_line (@lastusers)
	{
		($last_username, $last_userwhen) = split(/\|/, $lastuser_line);

		#is this user online now?
		$online_now = ($users =~ /username=$last_username"/) ? "<br>$lud_txt{'2'}" : '';

		#it should never happen, but a Guest entry might have been stored in the file. this avoids showing it 
		if (fopen(MFILE, "$memberdir/$last_username.dat"))
		{
			@memberinfo = <MFILE>; fclose(MFILE); chomp @memberinfo;
			$last_userwhen = &timeformat($last_userwhen) || $last_userwhen;

			#do we want to show an avatar?
			if ($rul_show_avatars)
			{
				#correct url allowing for custom avatars
				if ($memberinfo[13] =~ m~\Ahttp://~) { $avatar = $memberinfo[13]; }
				else { $avatar = $facesurl . '/' . $memberinfo[13]; }
			
				#is resizing enabled or shall we just show a plain image tag?
				#if we're using avatar resizing
				if ($rul_avatar_width || $rul_avatar_height)
				{
					#decide what the avatar link should be
					if ($rul_avatar_link == 2) { $avatars_cell = qq~<td><a href="$cgi;action=imsend;to=$last_username">\n<script language="JavaScript1.2" type="text/javascript"><!--\nresize_img("$avatar", "$lud_txt{'12'} $memberinfo[1]")\n--></script>\n</a></td>~; }
					elsif ($rul_avatar_link == 1) { $avatars_cell = qq~<td><a href="$cgi;action=viewprofile;username=$last_username">\n<script language="JavaScript1.2" type="text/javascript"><!--\nresize_img("$avatar", "$lud_txt{'13'} $memberinfo[1]")\n--></script>\n</a></td>~; }
					else { $avatars_cell = qq~<td>\n<script language="JavaScript1.2" type="text/javascript"><!--\nresize_img("$avatar", "$memberinfo[1]")\n--></script>\n</td>~; }
				}
				#else we're not using resizing so just use the normal image tag
				else
				{
					#decide what the avatar link should be
					if ($rul_avatar_link == 2) { $avatars_cell = qq~<td><a href="$cgi;action=imsend;to=$last_username"><img src="$avatar" border="0" alt="$lud_txt{'12'} $memberinfo[1]" hspace="3"></a></td>~; }
					elsif ($rul_avatar_link == 1) { $avatars_cell = qq~<td><a href="$cgi;action=viewprofile;username=$last_username"><img src="$avatar" border="0" alt="$lud_txt{'13'} $memberinfo[1]" hspace="3"></a></td>~; }
					else { $avatars_cell = qq~<td><img src="$avatar" border="0" alt="$memberinfo[1]" hspace="3"></td>~; }
				}
			}
			#else we're not showing avatars, so just show the text counter
			else { $avatars_cell = qq~<td valign="top"><font size="1">$counter.</font></td>~; }

			#output this row
			$yymain .= qq~<tr>$avatars_cell<td><font size="1" class="text2"><a href="$cgi;action=viewprofile;username=$last_username">$memberinfo[1]</a><br>$last_userwhen$online_now</font></td></tr>~;
			}

			$counter++;
	}

	$yymain .= qq~</table>~;
}



sub MarkAllRead {
	fopen(FILE, "$vardir/cat.txt");
	my @categories = <FILE>;
	fclose(FILE);
	my( $curcat, $curcatname, $curcataccess, @catboards, @membergroups, $openmemgr, $curboard );
	foreach $curcat (@categories) {
		chomp $curcat;
		fopen(FILE, "$boardsdir/$curcat.cat");
		$curcatname = <FILE>;
		$curcataccess = <FILE>;
		chomp $curcatname;
		chomp $curcataccess;
		@catboards = <FILE>;
		fclose(FILE);
		@membergroups = split( /,/, $curcataccess );
		$openmemgr = 0;
		foreach (@membergroups) {
			if( $_ eq $settings[7]) { $openmemgr = 1; last; }
		}
		if(!$curcataccess || $settings[7] eq 'Administrator') { $openmemgr = 1; }
		unless( $openmemgr ) { next; }
		foreach $curboard (@catboards) {
			chomp $curboard;
			&modlog("$curboard--mark");
			&modlog($curboard);
		}
	}
	&dumplog;
	&BoardIndex;
}

1;